<template>
  <div>
    <v-row justify="center">
      <v-col md="10">
        <Etiquetas
          v-model="etiqueta"
          :searchAction="getFoliosEtiquetaBusquedas"
          :disabled="loading"
        />
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="10">
        <div class="text-center text-h6 font-weight-bold">
          También podrás aprender a traves de los distintos niveles de
          información
        </div>
        <div class="text-center">
          Selecciona el nivel para desplegar los documentos asociados
        </div>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="10">
        <DirectorioArbol
          ref="directorioArbol"
          :disabled="loading"
          v-model="directorioArbol"
        />
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="10">
        <div v-if="etiquetaSearched && etiquetaSearched.descripcion">
          <span class="text-subtitle-2"
            >Documentos asociados a la etiqueta:
          </span>
          <v-chip x-small color="blue-grey" class="white--text">
            <span> {{ etiquetaSearched.descripcion }}</span>
          </v-chip>
        </div>
        <div v-if="directorioArbol && directorioArbol.descripcion">
          <span class="text-subtitle-2"
            ><strong>Documentos asociados del paso: </strong></span
          >
          <v-chip x-small color="blue-grey" class="white--text">
            <span> {{ directorioArbol.descripcion }}</span>
          </v-chip>
        </div>
        <div class="gris2">
          <v-row>
            <template v-for="(folio, indexFolio) in data">
              <v-col
                :cols="12"
                :key="indexFolio"
                :lg="4"
                :md="3"
                :sm="6"
                :xl="2"
              >
                <Documento :folio="folio" />
              </v-col>
            </template>
            <template v-if="notFound">
              <div class="text-h5 pa-3">No se encontrarón documentos...</div>
            </template>
          </v-row>
        </div>
      </v-col>
    </v-row>
    <v-row justify="center">
      <v-col md="10">
        <div v-if="etiquetaSearched && etiquetaSearched.descripcion">
          <template v-if="etiquetasRelacionadas.length > 0">
            <span class="text-subtitle-2"
              ><strong>Quizás también te interesen otros tags: </strong></span
            >
            <br />
            <template
              v-for="(etiquetaRelacionada, index) in etiquetasRelacionadas"
            >
              <v-chip
                :key="index"
                link
                color="blue-grey"
                class="white--text rounded-0 mb-1 mr-2"
                @click="selectTagAndSearch(etiquetaRelacionada)"
              >
                <span> {{ etiquetaRelacionada.descripcion }}</span>
              </v-chip>
            </template>
            <v-divider></v-divider>
          </template>
          <template v-else>
            <span class="text-subtitle-2"
              ><strong>No se encontraron etiquetas realacionadas </strong></span
            >
          </template>
        </div>
      </v-col>
    </v-row>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}

div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}

div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import store from "@/store";
import Etiquetas from "@/views/secure/modelo-negocio/documentos/visualizador/folios/etiqueta-arbol/components/Etiquetas.vue";
import DirectorioArbol from "@/views/secure/modelo-negocio/documentos/visualizador/folios/etiqueta-arbol/components/DirectorioArbol.vue";
import Documento from "@/views/secure/modelo-negocio/documentos/visualizador/folios/usuario/publicados/components/Documento.vue";
const serviceCommons = store.state.serviceCommons;
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  name: "Component-TablaFoliosEtiquetaArbol",
  components: {
    Etiquetas,
    DirectorioArbol,
    Documento,
  },
  data: (vm) => ({
    data: [],
    directorioArbol: null,
    loading: false,
    notFound: false,
    itemsPerPage: 10,
    etiqueta: null,
    etiquetasRelacionadas: [],
    etiquetaSearched: {},
    headers: [
      { text: "Documento", value: "documento.titulo", align: "center" },
      {
        text: "Unidad(es) de Negocio",
        value: "unidadesNegocio",
        align: "center",
      },
      { text: "Documentador", value: "creador.nombre", align: "center" },
    ],
  }),
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    user() {
      let user = serviceLocalStorage.userToken();
      if (!user) {
        user = {};
      }
      return user;
    },
  },
  watch: {
    etiqueta(val) {
      if (!val) {
        this.data = [];
        this.$emit("notSearch", true);
      } else {
        this.$emit("notSearch", false);
      }
      this.notFound = false;
    },
    directorioArbol(val, pre) {
      if (val) {
        this.$emit("notSearch", false);
        this.getFoliosNivelModeloBusquedas();
      } else {
        this.data = [];
        this.$emit("notSearch", true);
      }
      this.notFound = false;
    },
  },
  methods: {
    clear() {
      if (this.$refs.directorioArbol) {
        this.$refs.directorioArbol.clear();
      }
    },
    to(folio) {
      return {
        name: "modelo_negocio_publicados_comentarios_folio",
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folio.idFolio,
            documento: {
              titulo: folio.documento.titulo,
            },
          }),
        },
      };
    },
    classEstado(idEstadoFolio) {
      if (idEstadoFolio == 2) {
        return { "documentar--text": true };
      }
      if (idEstadoFolio == 3) {
        return { "revisar--text": true };
      }
      if (idEstadoFolio == 4) {
        return { "autorizar--text": true };
      }
      if (idEstadoFolio == 5) {
        return { "publicado--text": true };
      }
    },
    getFolioArchivosVirtuales(indexFolio) {
      let folio = this.data[indexFolio];
      folio.loading = true;
      axios(
        "/modelo-negocio/folio-virtuales-archivos/v1/" +
          folio.idFolio +
          "/virtuales/archivos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let files = data.resultado.folioVirtualesArchivos.filter(
              (item) => item.tipo == 1
            );
            if (files.length > 0) {
              folio.archivoDemo = files[0];
            }
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getFoliosNivelModeloBusquedas() {
      const self = this;
      this.loading = true;
      this.notFound = false;
      this.etiquetaSearched = {};
      this.etiqueta = null;
      axios(
        "/modelo-negocio/folios/v1/busquedas/usuarios/" +
          this.user.empleado +
          "/modelos-negocio/" +
          this.directorioArbol.idArbol
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let folios = data.resultado.folios;
            folios.forEach((element, indexElement) => {
              element.archivoDemo = null;
              element.loading = null;
            });
            self.data = folios;
            self.data.forEach((element, indexElement) => {
              self.getFolioArchivosVirtuales(indexElement);
            });
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.data = [];
            self.notFound = true;
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          self.loading = false;
        });
    },
    getFoliosEtiquetaBusquedas() {
      if (this.etiqueta) {
        const self = this;
        this.loading = true;
        this.notFound = false;
        this.etiquetaSearched = JSON.parse(JSON.stringify(this.etiqueta));
        this.clear();
        this.getEtiquetasRelacionadas();
        axios(
          "/modelo-negocio/folios/v1/busquedas/usuarios/" +
            this.user.empleado +
            "/etiquetas/" +
            this.etiqueta.idEtiqueta
        )
          .then((response) => {
            let data = response.data;
            if (data) {
              let folios = data.resultado.folios;
              folios.forEach((element, indexElement) => {
                element.archivoDemo = null;
                element.loading = null;
              });
              self.data = folios;
              self.data.forEach((element, indexElement) => {
                self.getFolioArchivosVirtuales(indexElement);
              });
            }
          })
          .catch((error) => {
            if (error.response && error.response.status == 404) {
              self.data = [];
              self.notFound = true;
            } else {
              console.log(error);
            }
          })
          .finally(() => {
            self.loading = false;
          });
      }
    },
    getEtiquetasRelacionadas() {
      const self = this;
      axios(
        "/modelo-negocio/catalogos/etiquetas/v1/" +
          this.etiqueta.idEtiqueta +
          "/relacionadas"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.etiquetasRelacionadas = data.resultado.etiquetas;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.etiquetasRelacionadas = [];
          } else {
            console.log(error);
          }
        });
    },
    selectTagAndSearch(etiqueta) {
      this.etiqueta = etiqueta;
      this.getFoliosEtiquetaBusquedas();
    },
  },
  created() {
    if (this.$route.query.etiqueta) {
      let etiqueta = this.serviceCommons.base64ToObject(
        this.$route.query.etiqueta
      );
      this.$router.replace({ query: {} });
      this.selectTagAndSearch(etiqueta);
    }
  },
};
</script>
